---
title: "Release v0.9.17"
linkTitle: "Release v0.9.17"
date: 2021-06-10
description: >
  Release v0.9.17
---

## Changelog since v0.9.15

### Notable Changes
* Ensure that primary workloads should be restarted when its config was updated ([#2054](https://github.com/pipe-cd/pipecd/pull/2054))
* Add the ability to display deployment even when missing the environment value ([#2045](https://github.com/pipe-cd/pipecd/pull/2045))
* Make it possible to delete environment from a web client ([#2031](https://github.com/pipe-cd/pipecd/pull/2031))
* The operator now can see the number of application of all projects ([#2015](https://github.com/pipe-cd/pipecd/pull/2015))
* Add badges at applications page to show the number of managing applications ([#2001](https://github.com/pipe-cd/pipecd/pull/2001))
* Fix broken layout at some pages on small screens ([#1977](https://github.com/pipe-cd/pipecd/pull/1977))
* Fix a wrong indent in piped Helm chart ([#2060](https://github.com/pipe-cd/pipecd/pull/2060))

### Internal Changes
* Bump web dependencies ([#2057](https://github.com/pipe-cd/pipecd/pull/2057))
* Fix showing deleted environments on deployments/applications' filter list ([#2044](https://github.com/pipe-cd/pipecd/pull/2044))
* Fix success alerts appear when deleting an environment returns failed. ([#2041](https://github.com/pipe-cd/pipecd/pull/2041))
* ECS progressive deployment preparation ([#2050](https://github.com/pipe-cd/pipecd/pull/2050))
* New stages sample for ECS progressive RFC ([#2052](https://github.com/pipe-cd/pipecd/pull/2052))
* Create a multi-valued composite index for ProjectId and EnvIds ([#2051](https://github.com/pipe-cd/pipecd/pull/2051))
* Disable EnvIds column ([#2049](https://github.com/pipe-cd/pipecd/pull/2049))
* Unify component story writing style ([#2048](https://github.com/pipe-cd/pipecd/pull/2048))
* Support contains operator for MySQL ([#2042](https://github.com/pipe-cd/pipecd/pull/2042))
* Add notes on how to apply changes on the dev cluster ([#2046](https://github.com/pipe-cd/pipecd/pull/2046))
* Don't use Deleted as a filtering field ([#2043](https://github.com/pipe-cd/pipecd/pull/2043))
* Do not show deleted/disabled environments/pipeds ([#2040](https://github.com/pipe-cd/pipecd/pull/2040))
* Fix drift detector to treat zero and unspecified values as equal ([#2037](https://github.com/pipe-cd/pipecd/pull/2037))
* Using array-contains instead of array-contains-any ([#2034](https://github.com/pipe-cd/pipecd/pull/2034))
* Ensure to delete environment gracefully ([#2029](https://github.com/pipe-cd/pipecd/pull/2029))
* Add delete environment rpc to auth list ([#2032](https://github.com/pipe-cd/pipecd/pull/2032))
* Fix the previous taskset remained on rollback failed ECS deployment ([#2030](https://github.com/pipe-cd/pipecd/pull/2030))
* Add dedicated operator type for datastore ([#2028](https://github.com/pipe-cd/pipecd/pull/2028))
* Fix applications fetching at the Application List page ([#2019](https://github.com/pipe-cd/pipecd/pull/2019))
* Ensure to reload alerting_rules file when changed ([#2023](https://github.com/pipe-cd/pipecd/pull/2023))
* Update eslint-plugin-react-hooks version ([#2025](https://github.com/pipe-cd/pipecd/pull/2025))
* Bump Bazel from 4.0.0 to 4.1.0 ([#2024](https://github.com/pipe-cd/pipecd/pull/2024))
* Add TaskSetDefinition as required configuration for ECS deployment ([#2021](https://github.com/pipe-cd/pipecd/pull/2021))
* Add web API to delete/disable environment ([#2016](https://github.com/pipe-cd/pipecd/pull/2016))
* Ignore prom-rules from rendering targets ([#2018](https://github.com/pipe-cd/pipecd/pull/2018))
* RFC for PipeCD ECS Application ([#1998](https://github.com/pipe-cd/pipecd/pull/1998))
* Update typescript to v4.3 ([#2014](https://github.com/pipe-cd/pipecd/pull/2014))
* Add Alertmanager configuration ([#1994](https://github.com/pipe-cd/pipecd/pull/1994))
* Reimplement ECS Sync with EXTERNAL deployment controller ([#2007](https://github.com/pipe-cd/pipecd/pull/2007))
* Remove unused fields in WebAPI struct ([#2008](https://github.com/pipe-cd/pipecd/pull/2008))
* Add web tests for the Application Counts ([#2006](https://github.com/pipe-cd/pipecd/pull/2006))
* Enable insight collector for application count by default ([#2004](https://github.com/pipe-cd/pipecd/pull/2004))
* Use tag to specify default value of config ([#2003](https://github.com/pipe-cd/pipecd/pull/2003))
* Update yup version ([#1999](https://github.com/pipe-cd/pipecd/pull/1999))
* Add hands-on tutorial guide in Japanese ([#1991](https://github.com/pipe-cd/pipecd/pull/1991))
* Refine ecs cloud provider ([#1996](https://github.com/pipe-cd/pipecd/pull/1996))
* Fix piped deployment to use the created service account only if it was created ([#1993](https://github.com/pipe-cd/pipecd/pull/1993))
* Update web API to return the real data of application counts ([#1990](https://github.com/pipe-cd/pipecd/pull/1990))
* Fix cron expression because the newer library does not allow specifying the second field ([#1989](https://github.com/pipe-cd/pipecd/pull/1989))
* Update release note v0.9.14 ([#1988](https://github.com/pipe-cd/pipecd/pull/1988))
* Add more log entries to insight collector ([#1987](https://github.com/pipe-cd/pipecd/pull/1987))
* Fix typo in the doc ([#1986](https://github.com/pipe-cd/pipecd/pull/1986))
* Refactor type of redux hooks ([#1981](https://github.com/pipe-cd/pipecd/pull/1981))
* Fix type error for web mock utils ([#1978](https://github.com/pipe-cd/pipecd/pull/1978))
* ECS Sync strategy refinement ([#1982](https://github.com/pipe-cd/pipecd/pull/1982))
* Add mention for actions-event-register within the doc ([#1985](https://github.com/pipe-cd/pipecd/pull/1985))
* Run cron job for insight collector only if it was enabled ([#1984](https://github.com/pipe-cd/pipecd/pull/1984))
* Refactor and redesign insight collector ([#1980](https://github.com/pipe-cd/pipecd/pull/1980))
* Add ECS deployment config template ([#1979](https://github.com/pipe-cd/pipecd/pull/1979))
* Unify the value placeholders in the docs ([#1976](https://github.com/pipe-cd/pipecd/pull/1976))
* Allow kubeconfig to be added to the secret ([#1965](https://github.com/pipe-cd/pipecd/pull/1965))
